"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var jsx_runtime_1 = require("react/jsx-runtime");
var react_1 = require("react");
var index_1 = __importDefault(require("./index"));
var each_1 = __importDefault(require("licia/each"));
var hooks_1 = require("../share/hooks");
var LunaObjectViewer = function (props) {
    var objectViewerRef = (0, react_1.useRef)(null);
    var objectViewer = (0, react_1.useRef)();
    (0, react_1.useEffect)(function () {
        var prototype = props.prototype, unenumerable = props.unenumerable, accessGetter = props.accessGetter, object = props.object;
        objectViewer.current = new index_1.default(objectViewerRef.current, {
            prototype: prototype,
            unenumerable: unenumerable,
            accessGetter: accessGetter,
            object: object,
        });
        return function () { var _a; return (_a = objectViewer.current) === null || _a === void 0 ? void 0 : _a.destroy(); };
    }, []);
    (0, each_1.default)(['object', 'prototype', 'unenumerable', 'accessGetter'], function (key) {
        (0, hooks_1.useNonInitialEffect)(function () {
            if (objectViewer.current) {
                objectViewer.current.setOption(key, props[key]);
            }
        }, [props[key]]);
    });
    return ((0, jsx_runtime_1.jsx)("div", { className: props.className || '', style: props.style, ref: objectViewerRef }));
};
exports.default = LunaObjectViewer;
